Code

integration: Split off mock_timeseries from mock_plugin.
[sysdb.git] / t / integration / query.sh
1 #! /bin/bash
2 #
3 # SysDB -- t/integration/basic_query.sh
4 # Copyright (C) 2012 Sebastian 'tokkee' Harl <sh@tokkee.org>
5 # All rights reserved.
6 #
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
9 # are met:
10 # 1. Redistributions of source code must retain the above copyright
11 #    notice, this list of conditions and the following disclaimer.
12 # 2. Redistributions in binary form must reproduce the above copyright
13 #    notice, this list of conditions and the following disclaimer in the
14 #    documentation and/or other materials provided with the distribution.
15 #
16 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
17 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
18 # TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
19 # PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
20 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
21 # EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
22 # PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
23 # OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
24 # WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
25 # OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
26 # ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
28 #
29 # Integration tests using basic queries.
30 #
32 set -ex
34 source "$( dirname "$0" )/test_lib.sh"
36 cat <<EOF > "$SYSDBD_CONF"
37 Listen "$SOCKET_FILE"
38 PluginDir "$PLUGIN_DIR"
39 Interval 2
41 LoadPlugin mock_timeseries
43 LoadBackend mock_plugin
44 <Backend "mock_plugin">
45 </Backend>
46 EOF
48 run_sysdbd -D -C "$SYSDBD_CONF"
50 wait_for_sysdbd
51 sleep 3
53 # Invalid user.
54 output="$( run_sysdb_nouser -H "$SOCKET_FILE" \
55   -U $SYSDB_USER-invalid -c 'LIST hosts' 2>&1 )" && exit 1
56 echo "$output" | grep -F 'Access denied'
58 # On parse errors, expect a non-zero exit code.
59 output="$( run_sysdb -H "$SOCKET_FILE" -c INVALID 2>&1 )" && exit 1
60 echo "$output" | grep "Failed to parse query 'INVALID'"
61 echo "$output" | grep "parse error: syntax error"
63 # Simple, successful commands.
64 output="$( run_sysdb -H "$SOCKET_FILE" -c 'LIST hosts' )"
65 echo "$output" \
66         | grep -F '"host1.example.com"' \
67         | grep -F '"host2.example.com"' \
68         | grep -F '"localhost"' \
69         | grep -F '"other.host.name"' \
70         | grep -F '"some.host.name"'
72 output="$( echo 'LIST hosts;' | run_sysdb -H "$SOCKET_FILE" )" || echo $?
73 echo "$output" \
74         | grep -F '"host1.example.com"' \
75         | grep -F '"host2.example.com"' \
76         | grep -F '"localhost"' \
77         | grep -F '"other.host.name"' \
78         | grep -F '"some.host.name"'
80 output="$( run_sysdb -H "$SOCKET_FILE" -c 'LIST services' )"
81 echo "$output" \
82         | grep -F '"host1.example.com"' \
83         | grep -F '"host2.example.com"' \
84         | grep -F '"localhost"' \
85         | grep -F '"some.host.name"' \
86         | grep -F '"mock service"' \
87         | grep -F '"other service"' \
88         | grep -F '"database"' \
89         | grep -F '"example service one"' \
90         | grep -F '"example service two"' \
91         | grep -F '"example service three"'
93 output="$( run_sysdb -H "$SOCKET_FILE" -c "FETCH host 'host1.example.com'" )"
94 echo "$output" \
95         | grep -F '"host1.example.com"' \
96         | grep -F '"mock service"' \
97         | grep -E '"other attribute".*"special value"'
98 echo "$output" | grep -F 'host2.example.com' && exit 1
99 echo "$output" | grep -F 'localhost' && exit 1
100 echo "$output" | grep -F 'other.host.name' && exit 1
101 echo "$output" | grep -F 'some.host.name' && exit 1
103 output="$( run_sysdb -H "$SOCKET_FILE" \
104   -c "FETCH host 'host1.example.com' FILTER last_update < 0" 2>&1 )" \
105   && exit 1
106 echo "$output" | grep -F 'not found'
108 (echo 'LIST hosts;'; sleep 1; echo "FETCH host 'host1.example.com'") \
109         | run_sysdb -H "$SOCKET_FILE"
111 # When requesting information for unknown hosts, expect a non-zero exit code.
112 output="$( run_sysdb -H "$SOCKET_FILE" \
113         -c "FETCH host 'does.not.exist'" 2>&1 )" && exit 1
114 echo "$output" | grep -F 'not found'
116 run_sysdb -H "$SOCKET_FILE" \
117                 -c "TIMESERIES 'invalid.host'.'invalid-metric'" && exit 1
119 # Does not work yet since there is no fetcher plugin.
120 output="$( run_sysdb -H "$SOCKET_FILE" \
121         -c "TIMESERIES 'some.host.name'.'foo/bar/qux'" )"
122 echo "$output" \
123         | grep -F '"value": "1.000000"' \
124         | grep -F '"value": "2.000000"' \
125         | grep -F '"value": "3.000000"' \
126         | grep -F '"value": "4.000000"' \
127         | grep -F '"value": "5.000000"' \
128         | grep -F '"value": "6.000000"' \
129         | grep -F '"value": "7.000000"' \
130         | grep -F '"value": "8.000000"' \
131         | grep -F '"value": "9.000000"' \
132         | grep -F '"value": "10.000000"'
134 stop_sysdbd
136 # vim: set tw=78 sw=4 ts=4 noexpandtab :